//+------------------------------------------------------------------+
//|                                                  e-SignalCSV.mq4 |
//|                                         Copyright  2010, Relrin |
//|                                    http://forum.forexpeoples.com |
//|                                                                  |
//|            |
//|  .     ,       |
//|   .                                                 |
//|              |
//|  ,                      |
//|                                                                  |
//|      signal.csv,                         |
//|                                    |
//|                                                                  |
//| 10001;2009.02.17 12:56;60;AUDUSD;buystop;0.1;0.6442;50;25;1      |
//|                                                                  |
//| :                                                             |
//|                                                                  |
//| 10001 -  ,     , |
//|                           |
//|                                                                  |
//| 2009.02.17 12:56;60 -     .         |
//|                  |
//| ,    , ,                |
//|   .                                      |
//|                                                                  |
//| 60 -   .                     |
//|  .                                              |
//|                                                                  |
//| AUDUSD -  .         |
//|   ,    ,          |
//| ,  .                                          |
//|                                                                  |
//| buystop -   (,    ) |
//|    buy                                                           |
//|    sell                                                          |
//|    buylimit                                                      |
//|    selllimit                                                     |
//|    buystop                                                        |
//|    sellstop                                                      |
//|                                                                  |
//| 0.1  -                                              |
//|                                                                  |
//| 0.6442;50;25 -  :                               |
//|  -  -                                            |
//|                                                                  |
//| 1 -   (1 - ,                        |
//| ; 0 - ,        |
//| ;    - )                              |
//|                                                                  |
//|              |
//|   (  ),          |
//|  .                                                    |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Relrin"
#property link      "http://forex.forexpeoples.com"

string Sgnl[][10];

#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//|      :)                             |
//+------------------------------------------------------------------+
int start()
  {
   TradeFromFile();
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
void TradeFromFile()
    {
    int k;
    int cnt = 0;
    int handle;
    string str;
    handle = FileOpen("signal.csv", FILE_READ);
    ArrayResize(Sgnl, 0);
    if (handle>0)
        {
        while (true)
            {
            ArrayResize(Sgnl, cnt + 1);
            k = 0;

            while (true)
                {
                Sgnl[cnt][k] = FileReadString(handle);
                k++;

                if (FileIsLineEnding(handle))
                    break;
                }

            if (k<10)
                {
                ArrayResize(Sgnl, cnt);
                }
            else
                cnt++;

            if (FileIsEnding(handle))
                {
                FileClose(handle);
                break;
                }
            }
        }
    
    for( int j = 0; j<ArraySize(Sgnl) / 10; j++ )
        {
        if (Sgnl[j][9] == "1")
            {
            SetOrders(StrToInteger(Sgnl[j][0]), Sgnl[j][3], Sgnl[j][4],StrToDouble(Sgnl[j][6]), StrToDouble(Sgnl[j][7]), StrToDouble(Sgnl[j][8]), StrToDouble(Sgnl[j][5]), StrToTime(Sgnl[j][1]), StrToTime(Sgnl[j][1])+ StrToInteger(Sgnl[j][2])*60);
            }
        if (Sgnl[j][9] == "0")
            {
            CloseOrder(StrToInteger(Sgnl[j][0]));
            }
        }
    }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void ExtOrderSend(int op, double ldLot, double ldOpen, double ldStop, double ldTake, int mn, string OrdSymbol, datetime OrdCancel )

    {
    color  clOpen;
    int ticket;
    string cmmnt = mn;

    if (op==0 || op==2 || op==4) 
        clOpen=Green; 
        else clOpen=Red;

//    while (!IsTradeAllowed())
//        Sleep(3000);

    ticket = OrderSend(OrdSymbol,op,ldLot,ldOpen,3,ldStop,ldTake,cmmnt,mn,OrdCancel,clOpen);

    if (ticket<0) {
      int err=GetLastError();
      Print("Error(",err,") ",ErrorDescription(err)," MAGIC ", mn," ",OrderTicket());
    }

    }
    
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|       ( = 1)     |
//+------------------------------------------------------------------+
void SetOrders(int OrdMn, string OrdSymbol,string OrdType, double OpenPrice, double TakeProfit, double StopLoss, double LotSize, datetime OrdStart, datetime OrdStop)
    {
    int Ord.Type;
    int RequoteAttempts=5;
    double TP,SL,ask,bid;
    
    if (!ExistPosition(OrdMn))
    {         
         if ((OrdType == "SELLLIMIT" || OrdType == "SellLimit" || OrdType == "selllimit") && OrdStart < TimeLocal() && OrdStop > TimeLocal())
            {
            if (MarketInfo(OrdSymbol,MODE_BID) + MarketInfo(OrdSymbol,MODE_STOPLEVEL)*MarketInfo(OrdSymbol,MODE_POINT) > OpenPrice) Ord.Type = 1;
            }
         
         if ((OrdType == "BUYLIMIT" || OrdType == "BuyLimit" || OrdType == "buylimit") && OrdStart < TimeLocal() && OrdStop > TimeLocal())
            {
            if (MarketInfo(OrdSymbol,MODE_ASK) - MarketInfo(OrdSymbol,MODE_STOPLEVEL)*MarketInfo(OrdSymbol,MODE_POINT) < OpenPrice) Ord.Type = 0;
            }
         if ((OrdType == "SELLSTOP" || OrdType == "SellStop" || OrdType == "sellstop") && OrdStart < TimeLocal() && OrdStop > TimeLocal())
            {
            if (MarketInfo(OrdSymbol,MODE_BID) - MarketInfo(OrdSymbol,MODE_STOPLEVEL)*MarketInfo(OrdSymbol,MODE_POINT) < OpenPrice) Ord.Type = 1;
            }
            
         if ((OrdType == "BUYSTOP" || OrdType == "BuyStop" || OrdType == "buystop") && OrdStart < TimeLocal() && OrdStop > TimeLocal())
            {
            if (MarketInfo(OrdSymbol,MODE_ASK) + MarketInfo(OrdSymbol,MODE_STOPLEVEL)*MarketInfo(OrdSymbol,MODE_POINT) > OpenPrice) Ord.Type = 0;
            }
       ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
         if ((OrdType == "BUY" || OrdType == "Buy" || OrdType == "buy") && OrdStart < TimeLocal() && OrdStop > TimeLocal())
            {
                Ord.Type  = 0;
                TP=NormalizeDouble(MarketInfo(OrdSymbol,MODE_ASK), MarketInfo(OrdSymbol,MODE_DIGITS))+TakeProfit*MarketInfo(OrdSymbol,MODE_POINT);
                SL=NormalizeDouble(MarketInfo(OrdSymbol,MODE_ASK), MarketInfo(OrdSymbol,MODE_DIGITS))-StopLoss*MarketInfo(OrdSymbol,MODE_POINT);
                OpenPrice = NormalizeDouble(MarketInfo(OrdSymbol,MODE_ASK), MarketInfo(OrdSymbol,MODE_DIGITS));
                ExtOrderSend(Ord.Type, LotSize, OpenPrice, SL, TP, OrdMn, OrdSymbol, OrdStop );
           
            }
       /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
         if ((OrdType == "SELL" || OrdType == "Sell" || OrdType == "sell") && OrdStart < TimeLocal() && OrdStop > TimeLocal()) 
            {
                Ord.Type = 1;
                TP=NormalizeDouble(MarketInfo(OrdSymbol,MODE_BID), MarketInfo(OrdSymbol,MODE_DIGITS))-TakeProfit*MarketInfo(OrdSymbol,MODE_POINT);
                SL=NormalizeDouble(MarketInfo(OrdSymbol,MODE_BID), MarketInfo(OrdSymbol,MODE_DIGITS))+StopLoss*MarketInfo(OrdSymbol,MODE_POINT);
                OpenPrice = NormalizeDouble(MarketInfo(OrdSymbol,MODE_BID), MarketInfo(OrdSymbol,MODE_DIGITS));
                ExtOrderSend(Ord.Type, LotSize, OpenPrice, SL, TP, OrdMn, OrdSymbol, OrdStop );         
            }
       /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
         if (OrdType == "SELLLIMIT" || OrdType == "SellLimit" || OrdType == "selllimit")
            {
              if (OrdStart < TimeLocal() && OrdStop > TimeLocal())
               {
                Ord.Type = 3;
                TP=OpenPrice-TakeProfit*MarketInfo(OrdSymbol,MODE_POINT);
                SL=OpenPrice+StopLoss*MarketInfo(OrdSymbol,MODE_POINT);
                ExtOrderSend(Ord.Type, LotSize, OpenPrice, SL, TP, OrdMn, OrdSymbol, OrdStop );         
               }   
            } 
       /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////     
         if (OrdType == "BUYLIMIT"  || OrdType == "BuyLimit"  || OrdType == "buylimit")
            {
              if (OrdStart < TimeLocal() && OrdStop > TimeLocal())
               {
                Ord.Type = 2;
                TP=OpenPrice-TakeProfit*MarketInfo(OrdSymbol,MODE_POINT);
                SL=OpenPrice+StopLoss*MarketInfo(OrdSymbol,MODE_POINT);
                ExtOrderSend(Ord.Type, LotSize, OpenPrice, SL, TP, OrdMn, OrdSymbol, OrdStop );         
               }   
            }     
       /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
           if (OrdType == "SELLSTOP"  || OrdType == "SellStop"  || OrdType == "sellstop")
            {
              if (OrdStart < TimeLocal() && OrdStop > TimeLocal())
               {
                Ord.Type = 5;
                TP=OpenPrice-TakeProfit*MarketInfo(OrdSymbol,MODE_POINT);
                SL=OpenPrice+StopLoss*MarketInfo(OrdSymbol,MODE_POINT);
                ExtOrderSend(Ord.Type, LotSize, OpenPrice, SL, TP, OrdMn, OrdSymbol, OrdStop );         
               }   
            } 
      /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
         if (OrdType == "BUYSTOP"   || OrdType == "BuyStop"   || OrdType == "buystop")
            {
              if (OrdStart < TimeLocal() && OrdStop > TimeLocal())
               {
                Ord.Type = 4;
                TP=OpenPrice+TakeProfit*MarketInfo(OrdSymbol,MODE_POINT);
                SL=OpenPrice-StopLoss*MarketInfo(OrdSymbol,MODE_POINT);
                ExtOrderSend(Ord.Type, LotSize, OpenPrice, SL, TP, OrdMn, OrdSymbol, OrdStop );         
               }   
            } 
      /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    }
    return (0);
    }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|      MAGIC             |
//+------------------------------------------------------------------+
bool ExistPosition(int MAGIC) {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderMagicNumber()==MAGIC) {

          Exist=True; break;

      }
    }
  }
  return(Exist);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|     ( = 0)             |
//+------------------------------------------------------------------+
void CloseOrder(int MAGIC)
    {
    int ticket;
    
    for( int i = 0; i<OrdersTotal(); i++ )
        {
        if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
            {
            if (OrderMagicNumber()==MAGIC)
                {
                if (OrderType() == 2 || OrderType() == 3 || OrderType() == 4 || OrderType() == 5)
                  {
                     ticket =OrderDelete(OrderTicket());
                     if (ticket<0) {
                        int err=GetLastError();
                        Print("Error(",err,") ",ErrorDescription(err)," MAGIC ", MAGIC," ",OrderTicket());
                        }
                    }
                }
            }
        }

    return (0);
    }
//+------------------------------------------------------------------+

